> For the complete documentation index, see [llms.txt](https://docs.scaleflex.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.scaleflex.com/developers-headless/headless-dam/media-asset-widget-maw/developer-reference.md).

# Developer reference

### Installation <a href="#od_c7238a00" id="od_c7238a00"></a>

Installing the MAW library happens over [npm](https://www.npmjs.com/package/@scaleflex/widget-core).

### Modules <a href="#od_05f3da56" id="od_05f3da56"></a>

The MAW consists of the [Core](https://www.npmjs.com/package/@scaleflex/widget-core#documentation) package and additional modules described below. The modules marked as required must be imported for the FMAW to function.

| Module                                                                                                                     | Required | Description                                                                                                                                                                                         |
| -------------------------------------------------------------------------------------------------------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [Explorer](https://www.npmjs.com/package/@scaleflex/widget-explorer)                                                       | yes      | Displays the folder structure and media gallery and provides file management capabilites.                                                                                                           |
| [XHR Upload](https://www.npmjs.com/package/@scaleflex/widget-xhr-upload)                                                   | yes      | Handles multipart file upload.                                                                                                                                                                      |
| [Status bar](https://www.npmjs.com/package/@scaleflex/widget-progress-panel)                                               | no       | Displays upload/download progress in a status bar.                                                                                                                                                  |
| [Informer](https://www.npmjs.com/package/@filerobot/informer/#filerobotinformer)                                           | no       | Displays pop-up messages/statuses related to file operations.                                                                                                                                       |
| [Thumbnail Generator](https://www.npmjs.com/package/@filerobot/thumbnail-generator/#Filerobothumbnail-generator)           | no       | Thumbnail generator for different file type previews.                                                                                                                                               |
| [Image Editor](https://www.npmjs.com/package/@scaleflex/widget-image-editor)                                               | no       | Inline image editor with functionalities such as filters, crop, resizing, watermark, collages, etc.... Also used by other features of the Widget such as the variant generator and export function. |
| [Image Annotator](https://www.npmjs.com/package/@filerobot/image-annotator/#filerobotimage-annotator)                      | no       | Inline image annotation and comment feed for people to collaborate on media assets.                                                                                                                 |
| [Webcam](https://www.npmjs.com/package/@scaleflex/widget-webcam)                                                           | no       | Captures photos or videos from the device's camera and upload them to the Filerobot storage container.                                                                                              |
| [Screen Capture](https://www.npmjs.com/package/@scaleflex/widget-screen-capture)                                           | no       | Device screen recorder and uploader                                                                                                                                                                 |
| [Pre-upload Image Processor](https://www.npmjs.com/package/@filerobot/preupload-processors/#filerobotpreupload-processors) | no       | Inline image editor prior the actual upload of the image to, for example, upload a resized version of a large image into the storage container.                                                     |

### Code examples <a href="#od_f62268df" id="od_f62268df"></a>

| Framework          | Link to code snippet                                                                                                                                                                                                                    |
| ------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| React              | [https://www.npmjs.com/package/@scaleflex/widget-core#:\~:text=and Vanilla JS.-,ReactJS,-(over package manager)](https://www.npmjs.com/package/@scaleflex/widget-core#:~:text=and%20Vanilla%20JS.-,ReactJS,-\(over%20package%20manager) |
| Vanilla (plain) JS | [https://www.npmjs.com/package/@scaleflex/widget-core#:\~:text=Scaleflex DAM API.-,Vanilla JS,-(over CDN link)](https://www.npmjs.com/package/@scaleflex/widget-core#:~:text=Scaleflex%20DAM%20API.-,Vanilla%20JS,-\(over%20CDN%20link) |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.scaleflex.com/developers-headless/headless-dam/media-asset-widget-maw/developer-reference.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
